Index: /XIOS/trunk/src/filter/unary_arithmetic_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/unary_arithmetic_filter.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/unary_arithmetic_filter.cpp	(revision 1704)
@@ -1,3 +1,6 @@
 #include "unary_arithmetic_filter.hpp"
+#include "workflow_graph.hpp"
+#include "yacc_var.hpp"
+#include "file.hpp"
 
 namespace xios
@@ -6,5 +9,63 @@
     : CFilter(gc, 1, this)
     , op(operatorExpr.getOpField(op))
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+  };
+
+  std::tuple<int, int, int> CUnaryArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    int unique_filter_id;
+    bool firstround;
+    
+    if(building_graph)
+    {
+      CWorkflowGraph::allocNodeEdge();
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround=true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+      
+        if(CWorkflowGraph::build_begin)
+        {
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+        }
+        else CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+      }
+      else 
+      {
+        firstround=false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]); 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }   
+      } 
+  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
 
   CDataPacketPtr CUnaryArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -15,4 +76,12 @@
     packet->status = data[0]->status;
 
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+
+    packet->field = this->field;
+
     if (packet->status == CDataPacket::NO_ERROR)
       packet->data.reference(op(data[0]->data));
Index: /XIOS/trunk/src/filter/unary_arithmetic_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/unary_arithmetic_filter.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/unary_arithmetic_filter.hpp	(revision 1704)
@@ -34,4 +34,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CUnaryArithmeticFilter
 } // namespace xios
Index: /XIOS/trunk/src/graphviz.cpp
===================================================================
--- /XIOS/trunk/src/graphviz.cpp	(revision 1704)
+++ /XIOS/trunk/src/graphviz.cpp	(revision 1704)
@@ -0,0 +1,151 @@
+#include "graphviz.hpp"
+#include "workflow_graph.hpp"
+
+namespace xios
+{
+
+  CGraphviz::CGraphviz()
+  { }
+
+  /*!
+   *
+   */
+  void CGraphviz::buildWorkflowGraphDot()
+  TRY
+  {
+    if (CWorkflowGraph::mapFieldToFilters_ptr_with_info !=0 && !CWorkflowGraph::mapFieldToFilters_ptr_with_info->empty())
+    {
+      CWorkflowGraph::buildStaticWorkflow();
+    
+      typedef boost::property<boost::edge_name_t, std::string> EdgeProperty;
+      typedef boost::adjacency_list<boost::vecS, boost::vecS, boost::directedS, boost::no_property, EdgeProperty> Graph;
+
+      // Input 1: nodes (=filters)
+      vector<StdString>& nodes = CWorkflowGraph::filters;
+      const int nbNodes = nodes.size();
+
+      // Input 2: edges (=fields)
+      vector<StdString>& edges = CWorkflowGraph::fields;
+
+      // Input 3: nodes to edges connectivity
+      vector<pair<int, int> >& nodesToEdges = CWorkflowGraph::fieldsToFilters;
+      const int nbEdges = nodesToEdges.size();
+
+      // Declare a graph object, adding the edges and edge properties
+      Graph g(nbNodes);
+      for (int j = 0; j < nbEdges; ++j)
+      {
+        graph_traits<Graph>::edge_descriptor e;
+        bool inserted;
+        boost::tie(e, inserted) = boost::add_edge(nodesToEdges[j].first, nodesToEdges[j].second, edges[j], g);
+      }
+
+      std::for_each(vertices(g).first, vertices(g).second, exercise_vertex<Graph>(g));
+
+      std::map<std::string,std::string> graph_attr, vertex_attr, edge_attr;
+      graph_attr["size"] = "5,5";
+      graph_attr["rankdir"] = "LR";
+      graph_attr["ratio"] = "fill";
+      vertex_attr["shape"] = "record";
+      vertex_attr["width"] = "2.2";
+      vertex_attr["fontsize"] = "16";
+
+      const std::string filename = "graph.dot";
+      std::ofstream file (filename.c_str());
+
+      boost::write_graphviz(file, g,
+          boost::make_label_writer(&nodes[0]),
+          boost::make_label_writer(get(edge_name, g)),
+          boost::make_graph_attributes_writer(graph_attr, vertex_attr, edge_attr));
+         
+    }
+  }
+  CATCH
+
+
+
+
+  void CGraphviz::buildWorkflowGraphVisjs_with_info()
+  TRY
+  {
+    if (CWorkflowGraph::mapFilters_ptr_with_info !=0 && !CWorkflowGraph::mapFilters_ptr_with_info->empty())
+    {
+      CWorkflowGraph::buildStaticWorkflow_with_info();
+
+      StdString color_table[7] = {"black", "red", "blue", "green", "purple", "yellow", "gray"};
+    
+      std::ofstream fs_json;
+      fs_json.open ("graph_data.json", std::fstream::out);
+
+      fs_json << "{\"nodes\":["<<std::endl<<"      ";
+      static bool firstnode=true;
+      static bool firstedge=true;
+    
+      for (auto it=CWorkflowGraph::mapFilters_ptr_with_info->begin(); it != CWorkflowGraph::mapFilters_ptr_with_info->end(); it++)
+      {
+        if(firstnode) 
+        {
+          fs_json << "{\"id\": "<<it->first +1<<", "<<std::endl;
+          firstnode = false;
+        }
+        else
+        {
+          fs_json << ",{\"id\": "<<it->first +1<<", "<<std::endl;
+        }
+        if(it->second.filter_class == 1) // source filter
+          fs_json << "       \"label\": \""<<it->second.filter_name<<"\\n("<<it->second.field_id<<")\", "<<std::endl;
+        else
+          fs_json << "       \"label\": \""<<it->second.filter_name<<"\", "<<std::endl;
+        fs_json << "       \"class\": "<<it->second.filter_class<<", "<<std::endl;
+        fs_json << "       \"filled\": "<<it->second.filter_filled<<", "<<std::endl;
+        fs_json << "       \"type\": \""<<it->second.transform_type<<"\", "<<std::endl;
+        fs_json << "       \"entry\": "<<it->second.expected_entry_nb<<", "<<std::endl;
+        fs_json << "       \"inputs\": "<<it->second.inputs_complete<<", "<<std::endl;
+        fs_json << "       \"tag\": "<<it->second.filter_tag<<", "<<std::endl;
+        fs_json << "       \"cid\": "<<it->second.clusterID<<", "<<std::endl;
+        fs_json << "       \"distance\": "<<it->second.distance<<", "<<std::endl;
+        fs_json << "       \"attributes\": \""<<it->second.attributes<<"\"}"<<std::endl<<"      ";
+      }
+      fs_json << "    ],"<<std::endl;
+
+
+      fs_json << " \"edges\" : ["<<std::endl<<"      ";
+
+      for (auto it=CWorkflowGraph::mapFieldToFilters_ptr_with_info->begin(); it != CWorkflowGraph::mapFieldToFilters_ptr_with_info->end(); it++)
+      {
+        if(firstedge)
+        {
+          fs_json << "{\"id\": "<<it->first +1<<", "<<std::endl;
+          firstedge = false;
+        }
+        else
+        {
+          fs_json << ",{\"id\": "<<it->first +1<<", "<<std::endl;
+        }
+        fs_json << "       \"from\": "<<it->second.from+1<<", "<<std::endl;
+        fs_json << "       \"to\": "<<it->second.to+1<<", "<<std::endl;
+        fs_json << "       \"label\": \""<<it->second.field_id<<"\\n"<<it->second.date<<"\", "<<std::endl;
+        // fs_json << "       \"title\": \""<<"Show more information about this field"<<"\", "<<std::endl;
+        // fs_json << "       \"fid\": \""<<it->second.field_id<<"\", "<<std::endl;
+        // fs_json << "       \"fname\": \""<<it->second.field_name<<"\", "<<std::endl;
+        // fs_json << "       \"gid\": \""<<it->second.grid_id<<"\", "<<std::endl;
+        fs_json << "       \"date\": \""<<it->second.date<<"\", "<<std::endl;
+        fs_json << "       \"attributes\": \"id = "<<it->second.field_id<<"</br>"<<it->second.attributes<<"\"}"<<std::endl<<"      ";
+
+      }
+      fs_json << "    ]}"<<std::endl;
+
+      fs_json.close();
+    }
+  }
+  CATCH
+
+
+
+  void CGraphviz::showStaticWorkflowGraph()
+  TRY
+  {
+    CWorkflowGraph::showStaticWorkflow();
+  }
+  CATCH
+}
Index: /XIOS/trunk/src/graphviz.hpp
===================================================================
--- /XIOS/trunk/src/graphviz.hpp	(revision 1704)
+++ /XIOS/trunk/src/graphviz.hpp	(revision 1704)
@@ -0,0 +1,35 @@
+#ifndef __GRAPHVIZ_HPP__
+#define __GRAPHVIZ_HPP__
+
+#include <algorithm>
+#include <boost/utility.hpp>
+#include <boost/graph/adjacency_list.hpp>
+#include <boost/graph/graphviz.hpp>
+
+namespace xios
+{
+
+  class CGraphviz
+  {
+
+    public:
+
+      CGraphviz();
+      static void buildWorkflowGraphDot();
+      static void buildWorkflowGraphVisjs_with_info();
+      static void showStaticWorkflowGraph();
+
+    private:
+      template <class Graph> struct exercise_vertex;
+
+  }; // class CGraphviz
+
+  template <class Graph> struct CGraphviz::exercise_vertex {
+    exercise_vertex(Graph& g_) : g(g_) { }
+    typedef typename boost::graph_traits<Graph>::vertex_descriptor Vertex;
+    void operator()(const Vertex& v) const { } Graph& g;
+  };
+
+} // namespace xios
+
+#endif
Index: /XIOS/trunk/src/node/field.cpp
===================================================================
--- /XIOS/trunk/src/node/field.cpp	(revision 1703)
+++ /XIOS/trunk/src/node/field.cpp	(revision 1704)
@@ -24,4 +24,5 @@
 #include "spatial_transform_filter.hpp"
 #include "file_server_writer_filter.hpp"
+#include "workflow_graph.hpp"
 
 namespace xios{
@@ -45,5 +46,8 @@
       , mustAutoTrigger(false)
       , isEOF(false), nstepMaxRead(false)
-   { setVirtualVariableGroup(CVariableGroup::create(getId() + "_virtual_variable_group")); }
+   { setVirtualVariableGroup(CVariableGroup::create(getId() + "_virtual_variable_group")); 
+     field_graph_start = -2;
+     field_graph_end = -2;
+   }
 
    CField::CField(const StdString& id)
@@ -63,5 +67,9 @@
       , mustAutoTrigger(false)
       , isEOF(false), nstepMaxRead(false)
-   { setVirtualVariableGroup(CVariableGroup::create(getId() + "_virtual_variable_group")); }
+   { setVirtualVariableGroup(CVariableGroup::create(getId() + "_virtual_variable_group")); 
+     field_graph_start = -2;
+     field_graph_end = -2;
+   }
+
 
    CField::~CField(void)
@@ -1106,14 +1114,72 @@
     *                     read by the client or/and written to a file
     */
-   void CField::buildFilterGraph(CGarbageCollector& gc, bool enableOutput)
+   void CField::buildFilterGraph(CGarbageCollector& gc, bool enableOutput, Time start_graph, Time end_graph)
    TRY
    {     
-    if (!isReferenceSolvedAndTransformed) solveAllEnabledFieldsAndTransform();
-    if (!isGridChecked) checkGridOfEnabledFields();
+     if (!isReferenceSolvedAndTransformed) solveAllEnabledFieldsAndTransform();
+     if (!isGridChecked) checkGridOfEnabledFields();
 
      const bool detectMissingValues = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
+     
+     const bool buildWorkflowGraph = (!build_workflow_graph.isEmpty() && build_workflow_graph == true);
+
+     
      const double defaultValue  = detectMissingValues ? default_value : (!default_value.isEmpty() ? default_value : 0.0);
 
      CContext* context = CContext::getCurrent();
+     
+     Time filter_start;
+     if(!build_workflow_graph_start.isEmpty() && buildWorkflowGraph) filter_start = context->calendar->getInitDate()+build_workflow_graph_start;
+     else if(build_workflow_graph_start.isEmpty() && buildWorkflowGraph) filter_start = 0;
+     else filter_start = -1;
+
+     Time filter_end;
+     if(!build_workflow_graph_end.isEmpty() && buildWorkflowGraph) filter_end = context->calendar->getInitDate()+build_workflow_graph_end;
+     else if(build_workflow_graph_end.isEmpty() && buildWorkflowGraph) filter_end = 9223372036854775807;
+     else filter_end = -1;
+
+     if(this->field_graph_start==-2) this->field_graph_start = filter_start;
+     if(this->field_graph_end==-2) this->field_graph_end = filter_end;         // init
+
+     // if(CXios::isClient) std::cout<<"****************** buildFilterGraph : field_id = "<<this->getId()<<" BEFORE: this->field_graph_start = "<<this->field_graph_start<<" this->field_graph_end = "<<this->field_graph_end<<std::endl;
+
+     if(start_graph == -1)
+     {
+       //nothing
+       // if(CXios::isClient) std::cout<<"buildFilterGraph field_id = "<<this->getId()<<" case1: this->field_graph_start = "<<this->field_graph_start<<std::endl;
+     }
+     else //if(start_graph != -1)
+     {
+       if(this->field_graph_start == -1) this->field_graph_start = start_graph;
+       else this->field_graph_start = min(this->field_graph_start, start_graph);
+
+       // if(CXios::isClient) std::cout<<"buildFilterGraph field_id = "<<this->getId()<<" case2: this->field_graph_start = "<<this->field_graph_start<<std::endl;
+     }
+
+
+     if(end_graph == -1)
+     {
+       //nothing
+       // if(CXios::isClient) std::cout<<"buildFilterGraph field_id = "<<this->getId()<<" case1: this->field_graph_end = "<<this->field_graph_end<<std::endl;
+     }
+     else
+     {
+       if(this->field_graph_end == -1) this->field_graph_end = end_graph;
+       else this->field_graph_end = max(this->field_graph_end, end_graph);
+
+       // if(CXios::isClient) std::cout<<"buildFilterGraph field_id = "<<this->getId()<<" case2: this->field_graph_end = "<<this->field_graph_end<<std::endl;
+     }
+    
+
+     filter_start = this->field_graph_start;
+     filter_end = this->field_graph_end;
+
+
+     // if(CXios::isClient) std::cout<<"****************** buildFilterGraph : field_id = "<<this->getId()<<" AFTER: this->field_graph_start = "<<this->field_graph_start<<" this->field_graph_end = "<<this->field_graph_end<<std::endl;
+     
+
+     
+     
+
      bool hasWriterServer = context->hasServer && !context->hasClient;
      bool hasIntermediateServer = context->hasServer && context->hasClient;
@@ -1159,5 +1225,5 @@
          {
            boost::scoped_ptr<IFilterExprNode> expr(parseExpr(getExpression() + '\0'));
-           std::shared_ptr<COutputPin> filter = expr->reduce(gc, *this);
+           std::shared_ptr<COutputPin> filter = expr->reduce(gc, *this, filter_start, filter_end);
 
            // Check if a spatial transformation is needed
@@ -1168,5 +1234,5 @@
              if (grid && grid != gridRef && grid->hasTransform())
              {
-                 std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = CSpatialTransformFilter::buildFilterGraph(gc, gridRef, grid, detectMissingValues, defaultValue); 
+               std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = CSpatialTransformFilter::buildFilterGraph(gc, gridRef, grid, detectMissingValues, defaultValue);
 
                filter->connectOutput(filters.first, 0);
@@ -1176,8 +1242,23 @@
 
            instantDataFilter = filter;
+           instantDataFilter->field = this;
+           filter->tag = buildWorkflowGraph;
+           
+           filter->start_graph = filter_start;
+           filter->end_graph = filter_end;
+
+           for(int i=0; i<filter->parent_filters.size(); i++)
+           {
+             filter->tag = filter->tag || filter->parent_filters[i]->tag;
+           }
          }
          // Check if we have a reference on another field
          else if (!field_ref.isEmpty())
-           instantDataFilter = getFieldReference(gc);
+         {
+           instantDataFilter = getFieldReference(gc, filter_start, filter_end);
+           instantDataFilter->tag = buildWorkflowGraph;
+           instantDataFilter->start_graph = filter_start;
+           instantDataFilter->end_graph = filter_end;
+         }
          // Check if the data is to be read from a file
          else if (file && !file->mode.isEmpty() && file->mode == CFile::mode_attr::read)
@@ -1186,4 +1267,9 @@
            instantDataFilter = serverSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid, true, false, freq_offset, true,
                                                                                                        detectMissingValues, defaultValue));
+           instantDataFilter->tag = buildWorkflowGraph;
+           instantDataFilter->start_graph = filter_start;
+           instantDataFilter->end_graph = filter_end;
+           instantDataFilter->field = this;
+
          }
          else // The data might be passed from the model
@@ -1191,5 +1277,10 @@
             if (check_if_active.isEmpty()) check_if_active = false; 
             instantDataFilter = clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid, false, true, NoneDu, false,
-                                                                                                        detectMissingValues, defaultValue));
+                                                                                                      detectMissingValues, defaultValue)); 
+            instantDataFilter->tag = buildWorkflowGraph;
+            instantDataFilter->start_graph = filter_start;
+            instantDataFilter->end_graph = filter_end;
+            instantDataFilter->field = this;
+            // if(CXios::isClient) std::cout<<"***********************buildFilterGraph init source filter : field_id = "<<this->getId()<<" sourcefilter->start_graph = "<<clientSourceFilter->start_graph<<" sourcefilter->end_graph = "<<clientSourceFilter->end_graph<<std::endl;
          }
        }
@@ -1203,4 +1294,14 @@
                                                                           detectMissingValues, defaultValue));
            instantDataFilter->connectOutput(storeFilter, 0);
+
+           storeFilter->tag = (instantDataFilter->tag || buildWorkflowGraph);
+           instantDataFilter->start_graph = filter_start;
+           instantDataFilter->end_graph = filter_end;
+
+           instantDataFilter->setParentFiltersTag();
+           storeFilter->start_graph = filter_start;
+           storeFilter->end_graph = filter_end;
+           storeFilter->field = this;
+           storeFilter->distance = instantDataFilter->distance+1;
          }
 
@@ -1209,4 +1310,16 @@
            fileWriterFilter = std::shared_ptr<CFileWriterFilter>(new CFileWriterFilter(gc, this));
            getTemporalDataFilter(gc, file->output_freq)->connectOutput(fileWriterFilter, 0);
+           
+           fileWriterFilter->tag = (getTemporalDataFilter(gc, file->output_freq)->tag || buildWorkflowGraph);
+           getTemporalDataFilter(gc, file->output_freq)->start_graph = filter_start;
+           getTemporalDataFilter(gc, file->output_freq)->end_graph = filter_end;
+           getTemporalDataFilter(gc, file->output_freq)->tag = buildWorkflowGraph;
+           getTemporalDataFilter(gc, file->output_freq)->setParentFiltersTag();
+           fileWriterFilter->start_graph = filter_start;
+           fileWriterFilter->end_graph = filter_end;
+           fileWriterFilter->distance = getTemporalDataFilter(gc, file->output_freq)->distance+1;
+
+           // std::cout<<"CFileWriterFilter filter start = "<<filter_start<<" end = "<<filter_end<<" field = "<<this->getId()<<std::endl;
+
          }
        }
@@ -1222,5 +1335,5 @@
     * \return the output pin corresponding to the field reference
     */
-   std::shared_ptr<COutputPin> CField::getFieldReference(CGarbageCollector& gc)
+   std::shared_ptr<COutputPin> CField::getFieldReference(CGarbageCollector& gc, Time start_graph, Time end_graph)
    TRY
    {
@@ -1230,5 +1343,55 @@
 
      CField* fieldRef = CField::get(field_ref);
-     fieldRef->buildFilterGraph(gc, false);
+     fieldRef->buildFilterGraph(gc, false, start_graph, end_graph);
+     const bool buildWorkflowGraph = (!build_workflow_graph.isEmpty() && build_workflow_graph == true);
+
+     CContext* context = CContext::getCurrent();
+
+     Time filter_start;
+     if(!build_workflow_graph_start.isEmpty() && buildWorkflowGraph) filter_start = context->calendar->getInitDate()+build_workflow_graph_start;
+     else if(build_workflow_graph_start.isEmpty() && buildWorkflowGraph) filter_start = 0;
+     else filter_start = -1;
+
+     Time filter_end;
+     if(!build_workflow_graph_end.isEmpty() && buildWorkflowGraph) filter_end = context->calendar->getInitDate()+build_workflow_graph_end;
+     else if(build_workflow_graph_end.isEmpty() && buildWorkflowGraph) filter_end = 9223372036854775807;
+     else filter_end = -1;
+
+     if(this->field_graph_start==-2) this->field_graph_start = filter_start;
+     if(this->field_graph_end==-2) this->field_graph_end = filter_end;         // init
+
+     // if(CXios::isClient) std::cout<<"getFieldReference field_id = "<<this->getId()<<" BEFORE: this->field_graph_start = "<<this->field_graph_start<<" this->field_graph_end = "<<this->field_graph_end<<std::endl;
+
+     if(start_graph == -1)
+     {
+       //nothing
+       // if(CXios::isClient) std::cout<<"getFieldReference field_id = "<<this->getId()<<" case1: this->field_graph_start = "<<this->field_graph_start<<std::endl;
+     }
+     else //if(start_graph != -1)
+     {
+       if(this->field_graph_start == -1) this->field_graph_start = start_graph;
+       else this->field_graph_start = min(this->field_graph_start, start_graph);
+
+       // if(CXios::isClient) std::cout<<"getFieldReference field_id = "<<this->getId()<<" case2: this->field_graph_start = "<<this->field_graph_start<<std::endl;
+     }
+
+     if(end_graph == -1)
+     {
+       //nothing
+       // if(CXios::isClient) std::cout<<"getFieldReference field_id = "<<this->getId()<<" case1: this->field_graph_end = "<<this->field_graph_end<<std::endl;
+     }
+     else
+     {
+       if(this->field_graph_end == -1) this->field_graph_end = end_graph;
+       else this->field_graph_end = max(this->field_graph_end, end_graph);
+
+       // if(CXios::isClient) std::cout<<"getFieldReference field_id = "<<this->getId()<<" case2: this->field_graph_end = "<<this->field_graph_end<<std::endl;
+     }
+
+     filter_start = this->field_graph_start;
+     filter_end = this->field_graph_end;
+
+     // if(CXios::isClient) std::cout<<"getFieldReference field_id = "<<this->getId()<<" AFTER: this->field_graph_start = "<<this->field_graph_start<<" this->field_graph_end = "<<this->field_graph_end<<std::endl;
+
 
      std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters;
@@ -1239,9 +1402,36 @@
        double defaultValue  = hasMissingValue ? default_value : (!default_value.isEmpty() ? default_value : 0.0);                                
        filters = CSpatialTransformFilter::buildFilterGraph(gc, fieldRef->grid, grid, hasMissingValue, defaultValue);
+
+       fieldRef->getInstantDataFilter()->connectOutput(filters.first, 0);
+
+     
+
+       filters.second->parent_filters.resize(1);
+       filters.second->parent_filters[0]= fieldRef->getInstantDataFilter();
+
+       filters.second->tag = (buildWorkflowGraph || filters.second->parent_filters[0]->tag);
+       
+       filters.second->start_graph = filter_start;
+       filters.second->end_graph = filter_end;
+       filters.second->field = this;
+       
      }
      else
+     {
        filters.first = filters.second = std::shared_ptr<CFilter>(new CPassThroughFilter(gc));
 
-     fieldRef->getInstantDataFilter()->connectOutput(filters.first, 0);
+       fieldRef->getInstantDataFilter()->connectOutput(filters.first, 0);
+     
+
+       filters.second->parent_filters.resize(1);
+       filters.second->parent_filters[0]= fieldRef->getInstantDataFilter();
+
+       filters.second->tag = (buildWorkflowGraph || filters.second->parent_filters[0]->tag);
+
+       filters.second->start_graph = filter_start;
+       filters.second->end_graph = filter_end;
+       filters.second->field = this;
+
+     }
 
      return filters.second;
@@ -1258,10 +1448,14 @@
     * \return the output pin corresponding to a self reference
     */
-   std::shared_ptr<COutputPin> CField::getSelfReference(CGarbageCollector& gc)
-   TRY
-   {
+   std::shared_ptr<COutputPin> CField::getSelfReference(CGarbageCollector& gc, Time start_graph, Time end_graph)
+   TRY
+   {
+     if(CXios::isClient) std::cout<<"getSelfReference field_id = "<<this->getId()<<" start_graph = "<<start_graph<<" end_graph = "<<end_graph<<std::endl;
+
      if (instantDataFilter || !hasExpression())
        ERROR("COutputPin* CField::getSelfReference(CGarbageCollector& gc)",
              "Impossible to add a self reference to a field which has already been parsed or which does not have an expression.");
+     
+     bool buildWorkflowGraph = (!build_workflow_graph.isEmpty() && build_workflow_graph == true);
 
      if (!selfReferenceFilter)
@@ -1300,4 +1494,6 @@
      }
 
+     selfReferenceFilter->tag = buildWorkflowGraph;
+     selfReferenceFilter->field = this;
      return selfReferenceFilter;
    }
@@ -1317,4 +1513,8 @@
    {
      std::map<CDuration, std::shared_ptr<COutputPin> >::iterator it = temporalDataFilters.find(outFreq);
+     const bool buildWorkflowGraph = (!build_workflow_graph.isEmpty() && build_workflow_graph == true);
+
+     CContext* context = CContext::getCurrent();
+
 
      if (it == temporalDataFilters.end())
@@ -1332,4 +1532,15 @@
 
        instantDataFilter->connectOutput(temporalFilter, 0);
+       // temporalFilter->tag = buildWorkflowGraph;
+       
+       temporalFilter->parent_filters.resize(1);
+       temporalFilter->parent_filters[0] = instantDataFilter;
+       
+
+       if(temporalFilter->parent_filters[0]->tag) temporalFilter->tag=true;
+
+       // temporalFilter->start_graph = filter_start;
+       // temporalFilter->end_graph = filter_end;
+       temporalFilter->field = this;
 
        it = temporalDataFilters.insert(std::make_pair(outFreq, temporalFilter)).first;
@@ -1367,9 +1578,13 @@
 
        const bool detectMissingValues = (!detect_missing_value.isEmpty() && detect_missing_value == true);
+       bool buildWorkflowGraph = (!build_workflow_graph.isEmpty() && build_workflow_graph == true);
        std::shared_ptr<CTemporalFilter> temporalFilter(new CTemporalFilter(gc, operation,
-                                                                             CContext::getCurrent()->getCalendar()->getInitDate(),
-                                                                             freq_op, freq_offset, outFreq, detectMissingValues));
+                                                                           CContext::getCurrent()->getCalendar()->getInitDate(),
+                                                                           freq_op, freq_offset, outFreq, detectMissingValues));
 
        selfReferenceFilter->connectOutput(temporalFilter, 0);
+       temporalFilter->tag = buildWorkflowGraph;
+       temporalFilter->field = this;
+
        return temporalFilter ;
      }
Index: /XIOS/trunk/src/node/field.hpp
===================================================================
--- /XIOS/trunk/src/node/field.hpp	(revision 1703)
+++ /XIOS/trunk/src/node/field.hpp	(revision 1704)
@@ -7,4 +7,5 @@
 #include "functor.hpp"
 #include "functor_type.hpp"
+#include "filter.hpp"
 #include "duration.hpp"
 #include "date.hpp"
@@ -139,10 +140,10 @@
          void checkTimeAttributes(CDuration* freqOp=NULL);
 
-         void buildFilterGraph(CGarbageCollector& gc, bool enableOutput);
+         void buildFilterGraph(CGarbageCollector& gc, bool enableOutput, Time start_graph=-1, Time end_graph=-1);
          size_t getGlobalWrittenSize(void) ;
          
          
-         std::shared_ptr<COutputPin> getFieldReference(CGarbageCollector& gc);
-         std::shared_ptr<COutputPin> getSelfReference(CGarbageCollector& gc);
+         std::shared_ptr<COutputPin> getFieldReference(CGarbageCollector& gc, Time start_graph=-1, Time end_graph=-1);
+         std::shared_ptr<COutputPin> getSelfReference(CGarbageCollector& gc, Time start_graph=-1, Time end_graph=-1);
          std::shared_ptr<COutputPin> getTemporalDataFilter(CGarbageCollector& gc, CDuration outFreq);
          std::shared_ptr<COutputPin> getSelfTemporalDataFilter(CGarbageCollector& gc, CDuration outFreq);
@@ -243,4 +244,7 @@
          bool hasTimeCentered;
 
+         Time field_graph_start;
+         Time field_graph_end;
+
 
          DECLARE_REF_FUNC(Field,field)
